Overview | Package | Class | Use | Tree | Deprecated | Index | Help
|  | BEA Systems, Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## weblogic.apache.xerces.dom
Class AttrImpl

    java.lang.Object
      |
      +--weblogic.apache.xerces.dom.NodeImpl
            |
            +--weblogic.apache.xerces.dom.AttrImpl

Direct Known Subclasses:
  AttrNSImpl, DeferredAttrImpl

public class AttrImpl
extends NodeImpl
implements org.w3c.dom.Attr

Attribute represents an XML-style attribute of an Element. Typically, the allowable values are controlled by its declaration in the Document Type Definition (DTD) governing this kind of document.

If the attribute has not been explicitly assigned a value, but has been declared in the DTD, it will exist and have that default. Only if neither the document nor the DTD specifies a value will the Attribute really be considered absent and have no value; in that case, querying the attribute will return null.

Attributes may have multiple children that contain their data. (XML allows attributes to contain entity references, and tokenized attribute types such as NMTOKENS may have a child for each token.) For convenience, the Attribute object's getValue() method returns the string version of the attribute's value.

Attributes are not children of the Elements they belong to, in the usual sense, and have no valid Parent reference. However, the spec says they _do_ belong to a specific Element, and an INUSE exception is to be thrown if the user attempts to explicitly share them between elements.

Note that Elements do not permit attributes to appear to be shared (see the INUSE exception), so this object's mutability is officially not an issue.

Note: The ownerNode attribute is used to store the Element the Attr node is associated with. Attr nodes do not have parent nodes. Besides, the getOwnerElement() method can be used to get the element node this attribute is associated with.

AttrImpl does not support Namespaces. AttrNSImpl, which inherits from it, does.

AttrImpl used to inherit from ParentNode. It now directly inherits from NodeImpl and provide its own implementation of the ParentNode's behavior. The reason is that we now try and avoid to always create a Text node to hold the value of an attribute. The DOM spec requires it, so we still have to do it in case getFirstChild() is called for instance. The reason attribute values are stored as a list of nodes is so that they can carry more than a simple string. They can also contain EntityReference nodes. However, most of the times people only have a single string that they only set and get through Element.set/getAttribute or Attr.set/getValue. In this new version, the Attr node has a value pointer which can either be the String directly or a pointer to the first ChildNode. A flag tells which one it currently is. Note that while we try to stick with the direct String as much as possible once we've switched to a node there is no going back. This is because we have no way to know whether the application keeps referring to the node we once returned.

The gain in memory varies on the density of attributes in the document. But in the tests I've run I've seen up to 12% of memory gain. And the good thing is that it also leads to a slight gain in speed because we allocate fewer objects! I mean, that's until we have to actually create the node...

To avoid too much duplicated code, I got rid of ParentNode and renamed ChildAndParentNode, which I never really liked, to ParentNode for simplicity, this doesn't make much of a difference in memory usage because there are only very few objects that are only a Parent. This is only true now because AttrImpl now inherits directly from NodeImpl and has its own implementation of the ParentNode's node behavior. So there is still some duplicated code there.

This class doesn't directly support mutation events, however, it notifies the document when mutations are performed so that the document class do so.

WARNING: Some of the code here is partially duplicated in ParentNode, be careful to keep these two classes in sync!

This class is based on an implementation from the Apache XML Project. In future releases the XML parser, XSLT processor, and associated classes will likely be updated to be based on a later version of the Apache implementations. Since Apache does not guarantee backwards compatibility between versions of their software, we cannot guarantee backwards compatibility of any of the classes contained in the weblogic.apache package or sub-packages.

Author:
  Arnaud Le Hors, IBM, Joe Kesselman, IBM, Andy Clark, IBM
See Also:
  `AttrNSImpl`, Serialized Form

Field Summary
`protected java.lang.String` | `name` Attribute name.
`protected static TextImpl` | `textNode`
`protected java.lang.Object` | `value` This can either be a String or the first child node.

Fields inherited from class weblogic.apache.xerces.dom.NodeImpl
`ELEMENT_DEFINITION_NODE, FIRSTCHILD, flags, HASSTRING, IGNORABLEWS, OWNED, ownerNode, READONLY, SPECIFIED, SYNCCHILDREN, SYNCDATA, UNNORMALIZED`

Constructor Summary
`protected` | `AttrImpl()`
`protected` | `AttrImpl(CoreDocumentImpl ownerDocument, java.lang.String name)` Attribute has no public constructor.

Method Summary
`org.w3c.dom.Node` | `cloneNode(boolean deep)`
`org.w3c.dom.NodeList` | `getChildNodes()` Obtain a NodeList enumerating all children of this node.
`org.w3c.dom.Element` | `getElement()` Deprecated. Previous working draft of DOM Level 2. New method is `getOwnerElement()`.
`org.w3c.dom.Node` | `getFirstChild()` The first child of this Node, or null if none.
`org.w3c.dom.Node` | `getLastChild()` The last child of this Node, or null if none.
`int` | `getLength()` NodeList method: Count the immediate children of this node
`java.lang.String` | `getName()` In Attributes, NodeName is considered a synonym for the attribute's Name
`java.lang.String` | `getNodeName()` Returns the attribute name
`short` | `getNodeType()` A short integer indicating what type of node this is.
`java.lang.String` | `getNodeValue()` In Attribute objects, NodeValue is considered a synonym for Value.
`org.w3c.dom.Element` | `getOwnerElement()` Returns the element node that this attribute is associated with, or null if the attribute has not been added to an element.
`boolean` | `getSpecified()` The "specified" flag is true if and only if this attribute's value was explicitly specified in the original document.
`java.lang.String` | `getValue()` The "string value" of an Attribute is its text representation, which in turn is a concatenation of the string values of its children.
`boolean` | `hasChildNodes()` Test whether this node has any children.
`org.w3c.dom.Node` | `insertBefore(org.w3c.dom.Node newChild, org.w3c.dom.Node refChild)` Move one or more node(s) to our list of children.
`org.w3c.dom.Node` | `item(int index)` NodeList method: Return the Nth immediate child of this node, or null if the index is out of bounds.
`protected void` | `makeChildNode()`
`void` | `normalize()`
`org.w3c.dom.Node` | `removeChild(org.w3c.dom.Node oldChild)` Remove a child from this Node.
`org.w3c.dom.Node` | `replaceChild(org.w3c.dom.Node newChild, org.w3c.dom.Node oldChild)` Make newChild occupy the location that oldChild used to have.
`void` | `setNodeValue(java.lang.String value)` Implicit in the rerouting of getNodeValue to getValue is the need to redefine setNodeValue, for symmetry's sake.
`void` | `setReadOnly(boolean readOnly, boolean deep)` Override default behavior so that if deep is true, children are also toggled.
`void` | `setSpecified(boolean arg)` NON-DOM, for use by parser
`void` | `setValue(java.lang.String newvalue)` The DOM doesn't clearly define what setValue(null) means.
`protected void` | `synchronizeChildren()` Override this method in subclass to hook in efficient internal data structure.
`java.lang.String` | `toString()` NON-DOM method for debugging convenience

Methods inherited from class weblogic.apache.xerces.dom.NodeImpl
`addEventListener, appendChild, changed, changes, dispatchEvent, getAttributes, getLocalName, getNamespaceURI, getNextSibling, getOwnerDocument, getParentNode, getPrefix, getPreviousSibling, getReadOnly, getUserData, hasAttributes, isSupported, removeEventListener, setPrefix, setUserData, synchronizeData`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### value

    protected java.lang.Object value

  This can either be a String or the first child node.

### name

    protected java.lang.String name

  Attribute name.

### textNode

    protected static TextImpl textNode

Constructor Detail

### AttrImpl

    protected AttrImpl(CoreDocumentImpl ownerDocument,
                       java.lang.String name)

  Attribute has no public constructor. Please use the factory method in the Document class.

### AttrImpl

    protected AttrImpl()

Method Detail

### makeChildNode

    protected void makeChildNode()

### cloneNode

    public org.w3c.dom.Node cloneNode(boolean deep)

  Overrides:
    cloneNode in class NodeImpl

### getNodeType

    public short getNodeType()

  A short integer indicating what type of node this is. The named constants for this value are defined in the org.w3c.dom.Node interface.

  Overrides:
    getNodeType in class NodeImpl

### getNodeName

    public java.lang.String getNodeName()

  Returns the attribute name

  Overrides:
    getNodeName in class NodeImpl

### setNodeValue

    public void setNodeValue(java.lang.String value)
                      throws org.w3c.dom.DOMException

  Implicit in the rerouting of getNodeValue to getValue is the need to redefine setNodeValue, for symmetry's sake. Note that since we're explicitly providing a value, Specified should be set true.... even if that value equals the default.

  Overrides:
    setNodeValue in class NodeImpl

### getNodeValue

    public java.lang.String getNodeValue()

  In Attribute objects, NodeValue is considered a synonym for Value.

  Overrides:
    getNodeValue in class NodeImpl
  See Also:
    `getValue()`

### getName

    public java.lang.String getName()

  In Attributes, NodeName is considered a synonym for the attribute's Name
  Specified by:
    getName in interface org.w3c.dom.Attr

### setValue

    public void setValue(java.lang.String newvalue)

  The DOM doesn't clearly define what setValue(null) means. I've taken it as "remove all children", which from outside should appear similar to setting it to the empty string.
  Specified by:
    setValue in interface org.w3c.dom.Attr

### getValue

    public java.lang.String getValue()

  The "string value" of an Attribute is its text representation, which in turn is a concatenation of the string values of its children.
  Specified by:
    getValue in interface org.w3c.dom.Attr

### getSpecified

    public boolean getSpecified()

  The "specified" flag is true if and only if this attribute's value was explicitly specified in the original document. Note that the implementation, not the user, is in charge of this property. If the user asserts an Attribute value (even if it ends up having the same value as the default), it is considered a specified attribute. If you really want to revert to the default, delete the attribute from the Element, and the Implementation will re-assert the default (if any) in its place, with the appropriate specified=false setting.
  Specified by:
    getSpecified in interface org.w3c.dom.Attr

### getElement

    public org.w3c.dom.Element getElement()

  Deprecated. Previous working draft of DOM Level 2. New method is `getOwnerElement()`.
  Returns the element node that this attribute is associated with, or null if the attribute has not been added to an element.

  See Also:
    `getOwnerElement()`

### getOwnerElement

    public org.w3c.dom.Element getOwnerElement()

  Returns the element node that this attribute is associated with, or null if the attribute has not been added to an element.
  Specified by:
    getOwnerElement in interface org.w3c.dom.Attr

### normalize

    public void normalize()

  Overrides:
    normalize in class NodeImpl

### setSpecified

    public void setSpecified(boolean arg)

  NON-DOM, for use by parser

### toString

    public java.lang.String toString()

  NON-DOM method for debugging convenience

  Overrides:
    toString in class NodeImpl

### hasChildNodes

    public boolean hasChildNodes()

  Test whether this node has any children. Convenience shorthand for (Node.getFirstChild()!=null)

  Overrides:
    hasChildNodes in class NodeImpl

### getChildNodes

    public org.w3c.dom.NodeList getChildNodes()

  Obtain a NodeList enumerating all children of this node. If there are none, an (initially) empty NodeList is returned.

  NodeLists are "live"; as children are added/removed the NodeList will immediately reflect those changes. Also, the NodeList refers to the actual nodes, so changes to those nodes made via the DOM tree will be reflected in the NodeList and vice versa.

  In this implementation, Nodes implement the NodeList interface and provide their own getChildNodes() support. Other DOMs may solve this differently.

  Overrides:
    getChildNodes in class NodeImpl

### getFirstChild

    public org.w3c.dom.Node getFirstChild()

  The first child of this Node, or null if none.

  Overrides:
    getFirstChild in class NodeImpl

### getLastChild

    public org.w3c.dom.Node getLastChild()

  The last child of this Node, or null if none.

  Overrides:
    getLastChild in class NodeImpl

### insertBefore

    public org.w3c.dom.Node insertBefore(org.w3c.dom.Node newChild,
                                         org.w3c.dom.Node refChild)
                                  throws org.w3c.dom.DOMException

  Move one or more node(s) to our list of children. Note that this implicitly removes them from their previous parent.

  Parameters:
    `newChild` - The Node to be moved to our subtree. As a convenience feature, inserting a DocumentNode will instead insert all its children.
    `refChild` - Current child which newChild should be placed immediately before. If refChild is null, the insertion occurs after all existing Nodes, like appendChild().
  Throws:
    DOMException(HIERARCHY_REQUEST_ERR) - if newChild is of a type that shouldn't be a child of this node, or if newChild is an ancestor of this node.
    DOMException(WRONG_DOCUMENT_ERR) - if newChild has a different owner document than we do.
    DOMException(NOT_FOUND_ERR) - if refChild is not a child of this node.
    DOMException(NO_MODIFICATION_ALLOWED_ERR) - if this node is read-only.
  Overrides:
    insertBefore in class NodeImpl

### removeChild

    public org.w3c.dom.Node removeChild(org.w3c.dom.Node oldChild)
                                 throws org.w3c.dom.DOMException

  Remove a child from this Node. The removed child's subtree remains intact so it may be re-inserted elsewhere.

  Returns:
    oldChild, in its new state (removed).
  Throws:
    DOMException(NOT_FOUND_ERR) - if oldChild is not a child of this node.
    DOMException(NO_MODIFICATION_ALLOWED_ERR) - if this node is read-only.
  Overrides:
    removeChild in class NodeImpl

### replaceChild

    public org.w3c.dom.Node replaceChild(org.w3c.dom.Node newChild,
                                         org.w3c.dom.Node oldChild)
                                  throws org.w3c.dom.DOMException

  Make newChild occupy the location that oldChild used to have. Note that newChild will first be removed from its previous parent, if any. Equivalent to inserting newChild before oldChild, then removing oldChild.

  Throws:
    DOMException(HIERARCHY_REQUEST_ERR) - if newChild is of a type that shouldn't be a child of this node, or if newChild is one of our ancestors.
    DOMException(WRONG_DOCUMENT_ERR) - if newChild has a different owner document than we do.
    DOMException(NOT_FOUND_ERR) - if oldChild is not a child of this node.
    DOMException(NO_MODIFICATION_ALLOWED_ERR) - if this node is read-only.
  Overrides:
    replaceChild in class NodeImpl

### getLength

    public int getLength()

  NodeList method: Count the immediate children of this node

  Returns:
    int
  Overrides:
    getLength in class NodeImpl

### item

    public org.w3c.dom.Node item(int index)

  NodeList method: Return the Nth immediate child of this node, or null if the index is out of bounds.

  Parameters:
    `Index` - int
  Returns:
    org.w3c.dom.Node
  Overrides:
    item in class NodeImpl

### setReadOnly

    public void setReadOnly(boolean readOnly,
                            boolean deep)

  Override default behavior so that if deep is true, children are also toggled.

  Overrides:
    setReadOnly in class NodeImpl
  See Also:

    Note: this will not change the state of an EntityReference or its children, which are always read-only.

### synchronizeChildren

    protected void synchronizeChildren()

  Override this method in subclass to hook in efficient internal data structure.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Documentation is available at http://e-docs.bea.com/wls/docs70
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2004 BEA Systems, Inc. All Rights Reserved.
WebLogic Server 7.0 API Reference